#pragma once
#include "resource.h"       // main symbols
#include "MSOClipHelper_i.h"

// actually, this looks more like a resize than a clear, but it works fine!
typedef int(__stdcall * clearclipfunc_f)(int, int, int);
typedef int(__stdcall * getcountfunc_f)();

struct officefuncs
{
	officefuncs() {}
	officefuncs(clearclipfunc_f clearclipfunc_a,getcountfunc_f getcountfunc_a) : clearclipfunc(clearclipfunc_a), getcountfunc(getcountfunc_a) {}
	clearclipfunc_f clearclipfunc;
	getcountfunc_f  getcountfunc;
};

// COfficeClipHelper

class ATL_NO_VTABLE COfficeClipHelper :
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<COfficeClipHelper, &CLSID_OfficeClipHelper>,
	public ISupportErrorInfo,
	public IDispatchImpl<IOfficeClipHelper, &IID_IOfficeClipHelper, &LIBID_MSOClipHelperLib, /*wMajor =*/ 1, /*wMinor =*/ 0>
{
	// non creatable, so we don't have to worry about invalid data in here.
	officefuncs m_ofs;
	CComBSTR m_descr;
	HMODULE m_hnd;
public:
	COfficeClipHelper()
	{
	}
	void initialize(officefuncs & ofuncs, CComBSTR descr, HMODULE handle)
	{
		m_ofs = ofuncs;
		m_descr = descr;
		m_hnd = handle;
	}

DECLARE_REGISTRY_RESOURCEID(IDR_OFFICECLIPHELPER)


BEGIN_COM_MAP(COfficeClipHelper)
	COM_INTERFACE_ENTRY(IOfficeClipHelper)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
END_COM_MAP()

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);


	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		return S_OK;
	}

	void FinalRelease()
	{
	}

public:

	STDMETHOD(get_NumClipItems)(LONG* pVal);
	STDMETHOD(Clear)(void);
	STDMETHOD(get_Description)(BSTR* pVal);
};

//OBJECT_ENTRY_AUTO(__uuidof(OfficeClipHelper), COfficeClipHelper)
